blob: 753a6de4b7ae41bbdba71830c5864b0d327f2317 [file] [log] [blame]
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01001# SPDX-License-Identifier: GPL-2.0
Linus Torvalds1da177e2005-04-16 15:20:36 -07002# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
Masahiro Yamada911a91c2018-03-01 15:34:37 +09006PHONY += xconfig gconfig menuconfig config syncconfig update-po-config \
Steven Rostedt281c9da2009-04-29 22:52:23 -04007 localmodconfig localyesconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -07008
Al Viro61bee202008-08-25 04:51:27 -04009ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
Arnaud Lacombe838a2e52010-09-04 17:10:20 -040012Kconfig := Kconfig
Al Viro61bee202008-08-25 04:51:27 -040013endif
Sam Ravnborge703f752007-10-25 20:42:18 +020014
Michal Marek0a1f00a2015-04-08 13:30:42 +020015ifeq ($(quiet),silent_)
16silent := -s
17endif
18
Yann E. MORINc2838e62012-11-22 01:06:04 +010019# We need this, in case the user has it in its environment
20unexport CONFIG_
21
Linus Torvalds1da177e2005-04-16 15:20:36 -070022xconfig: $(obj)/qconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020023 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070024
25gconfig: $(obj)/gconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020026 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070027
28menuconfig: $(obj)/mconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020029 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070030
31config: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020032 $< $(silent) --oldaskconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070033
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020034nconfig: $(obj)/nconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020035 $< $(silent) $(Kconfig)
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020036
Marc Herbertcedd55d2018-01-26 14:59:00 -080037# This has become an internal implementation detail and is now deprecated
38# for external use.
Masahiro Yamada911a91c2018-03-01 15:34:37 +090039syncconfig: $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090040 $(Q)mkdir -p include/config include/generated
Nicolas Pitred3fc4252016-11-30 17:41:58 -050041 $(Q)test -e include/generated/autoksyms.h || \
42 touch include/generated/autoksyms.h
Michal Marek0a1f00a2015-04-08 13:30:42 +020043 $< $(silent) --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070044
Arnaud Lacombe50bce3e2011-07-01 18:13:03 -040045localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090046 $(Q)mkdir -p include/config include/generated
Arnaud Lacombe22d550a2011-07-20 00:40:09 -040047 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
Michal Marek7a996d32010-08-04 14:05:07 +020048 $(Q)if [ -f .config ]; then \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020049 cmp -s .tmp.config .config || \
50 (mv -f .config .config.old.1; \
51 mv -f .tmp.config .config; \
Masahiro Yamada81d2bc22018-03-01 15:34:36 +090052 $(obj)/conf $(silent) --oldconfig $(Kconfig); \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020053 mv -f .config.old.1 .config.old) \
54 else \
55 mv -f .tmp.config .config; \
Masahiro Yamada81d2bc22018-03-01 15:34:36 +090056 $(obj)/conf $(silent) --oldconfig $(Kconfig); \
Steven Rostedta7c02602009-05-07 11:09:55 -040057 fi
Steven Rostedt03fa25d2009-04-29 22:52:22 -040058 $(Q)rm -f .tmp.config
59
EGRY Gabor10200262008-01-11 23:40:00 +010060# Create new linux.pot file
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020061# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
EGRY Gabor46d26312008-01-11 23:46:11 +010062update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
Michal Marek0a1f00a2015-04-08 13:30:42 +020063 $(Q)$(kecho) " GEN config.pot"
Peter Foleya24a1b82011-04-26 18:13:05 -040064 $(Q)xgettext --default-domain=linux \
65 --add-comments --keyword=_ --keyword=N_ \
66 --from-code=UTF-8 \
67 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
68 --directory=$(srctree) --directory=$(objtree) \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020069 --output $(obj)/config.pot
70 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
Paul Bollefa0ad6572011-11-05 12:21:30 +010071 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
72 $(srctree)/arch/*/um/Kconfig`; \
EGRY Gabor10200262008-01-11 23:40:00 +010073 do \
Michal Marek0a1f00a2015-04-08 13:30:42 +020074 $(kecho) " GEN $$i"; \
Sam Ravnborg42175162008-04-25 21:15:41 +020075 $(obj)/kxgettext $$i \
EGRY Gabor10200262008-01-11 23:40:00 +010076 >> $(obj)/config.pot; \
77 done )
Michal Marek0a1f00a2015-04-08 13:30:42 +020078 $(Q)$(kecho) " GEN linux.pot"
EGRY Gabor10200262008-01-11 23:40:00 +010079 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020080 --output $(obj)/linux.pot
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020081 $(Q)rm -f $(obj)/config.pot
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -070082
Michal Marek1cba0c32015-04-08 11:11:57 +020083# These targets map 1:1 to the commandline options of 'conf'
84simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
85 alldefconfig randconfig listnewconfig olddefconfig
86PHONY += $(simple-targets)
Linus Torvalds1da177e2005-04-16 15:20:36 -070087
Michal Marek1cba0c32015-04-08 11:11:57 +020088$(simple-targets): $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020089 $< $(silent) --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070090
Masahiro Yamada911a91c2018-03-01 15:34:37 +090091PHONY += oldnoconfig silentoldconfig savedefconfig defconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -070092
Adam Leefb16d892012-09-01 01:05:17 +080093# oldnoconfig is an alias of olddefconfig, because people already are dependent
Diego Viola39c3f1b2015-05-31 14:35:51 -030094# on its behavior (sets new symbols to their default value but not 'n') with the
Adam Leefb16d892012-09-01 01:05:17 +080095# counter-intuitive name.
Michal Marek1cba0c32015-04-08 11:11:57 +020096oldnoconfig: olddefconfig
Masahiro Yamada312ee682018-01-18 13:13:43 +090097 @echo " WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
98 @echo " Please use \"olddefconfig\" instead, which is an alias."
Adam Leefb16d892012-09-01 01:05:17 +080099
Masahiro Yamada911a91c2018-03-01 15:34:37 +0900100# We do not expect manual invokcation of "silentoldcofig" (or "syncconfig").
101silentoldconfig: syncconfig
102 @echo " WARNING: \"silentoldconfig\" has been renamed to \"syncconfig\""
103 @echo " and is now an internal implementation detail."
104 @echo " What you want is probably \"oldconfig\"."
105 @echo " \"silentoldconfig\" will be removed after Linux 4.19"
106
Sam Ravnborg7cf3d732010-07-31 23:35:34 +0200107savedefconfig: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +0200108 $< $(silent) --$@=defconfig $(Kconfig)
Sam Ravnborg7cf3d732010-07-31 23:35:34 +0200109
Linus Torvalds1da177e2005-04-16 15:20:36 -0700110defconfig: $(obj)/conf
111ifeq ($(KBUILD_DEFCONFIG),)
Michal Marek0a1f00a2015-04-08 13:30:42 +0200112 $< $(silent) --defconfig $(Kconfig)
Jan Beulich42f9d3c2016-01-25 09:45:47 -0700113else
114ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
Michal Marek0a1f00a2015-04-08 13:30:42 +0200115 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
116 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
Michael Ellermand2036f32015-09-23 15:40:34 +1000117else
118 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
119 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700120endif
Jan Beulich42f9d3c2016-01-25 09:45:47 -0700121endif
Linus Torvalds1da177e2005-04-16 15:20:36 -0700122
123%_defconfig: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +0200124 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700125
Masahiro Yamada63a91032015-03-13 15:21:43 +0900126configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
Josh Triplett3aaefce2014-08-06 15:21:00 -0700127
Masahiro Yamada63a91032015-03-13 15:21:43 +0900128%.config: $(obj)/conf
129 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
130 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
131 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
Josh Triplett3aaefce2014-08-06 15:21:00 -0700132
133PHONY += kvmconfig
Masahiro Yamada63a91032015-03-13 15:21:43 +0900134kvmconfig: kvm_guest.config
135 @:
Josh Triplett3aaefce2014-08-06 15:21:00 -0700136
Luis R. Rodriguez6c668502015-05-20 11:53:39 -0700137PHONY += xenconfig
138xenconfig: xen.config
139 @:
140
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700141PHONY += tinyconfig
Masahiro Yamada63a91032015-03-13 15:21:43 +0900142tinyconfig:
143 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700144
Linus Torvalds1da177e2005-04-16 15:20:36 -0700145# Help text used by make help
146help:
147 @echo ' config - Update current config utilising a line-oriented program'
Geert Uytterhoevenfa75a722015-05-26 13:39:54 +0200148 @echo ' nconfig - Update current config utilising a ncurses menu based'
149 @echo ' program'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700150 @echo ' menuconfig - Update current config utilising a menu based program'
Diego Viola092373c2015-04-06 06:27:45 -0300151 @echo ' xconfig - Update current config utilising a Qt based front-end'
Diego Viola39c3f1b2015-05-31 14:35:51 -0300152 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700153 @echo ' oldconfig - Update current config utilising a provided .config as base'
Steven Rostedt03fa25d2009-04-29 22:52:22 -0400154 @echo ' localmodconfig - Update current config disabling modules not loaded'
Steven Rostedt281c9da2009-04-29 22:52:23 -0400155 @echo ' localyesconfig - Update current config converting local mods to core'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200156 @echo ' defconfig - New config with default from ARCH supplied defconfig'
Sam Ravnborg7cf3d732010-07-31 23:35:34 +0200157 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
Jesper Juhle11f0492006-02-25 21:52:50 +0100158 @echo ' allnoconfig - New config where all options are answered with no'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200159 @echo ' allyesconfig - New config where all options are accepted with yes'
160 @echo ' allmodconfig - New config selecting modules when possible'
161 @echo ' alldefconfig - New config with all symbols set to default'
162 @echo ' randconfig - New config with random answer to all options'
Sam Ravnborg861b4ea2010-07-31 23:35:28 +0200163 @echo ' listnewconfig - List new options'
Marc Herbertcedd55d2018-01-26 14:59:00 -0800164 @echo ' olddefconfig - Same as oldconfig but sets new symbols to their'
165 @echo ' default value without prompting'
Luis R. Rodriguez9bcd7762015-05-20 11:53:38 -0700166 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
Luis R. Rodriguez6c668502015-05-20 11:53:39 -0700167 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700168 @echo ' tinyconfig - Configure the tiniest possible kernel'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700169
Sam Ravnborg2982de62006-07-27 22:10:27 +0200170# lxdialog stuff
171check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
172
Rob Landleye9e40e12007-10-15 19:23:12 -0500173# Use recursively expanded variables so we do not call gcc unless
Sam Ravnborg2982de62006-07-27 22:10:27 +0200174# we really need to do so. (Do not call gcc as part of make mrproper)
Arnaud Lacombe9ba95682010-08-22 20:03:06 -0400175HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
176 -DLOCALE
Sam Ravnborg2982de62006-07-27 22:10:27 +0200177
Linus Torvalds1da177e2005-04-16 15:20:36 -0700178# ===========================================================================
179# Shared Makefile for the various kconfig executables:
180# conf: Used for defconfig, oldconfig and related targets
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200181# nconf: Used for the nconfig target.
182# Utilizes ncurses
Markus Heidelberg6f26e5e2009-05-18 01:36:45 +0200183# mconf: Used for the menuconfig target
Linus Torvalds1da177e2005-04-16 15:20:36 -0700184# Utilizes the lxdialog package
185# qconf: Used for the xconfig target
Diego Viola092373c2015-04-06 06:27:45 -0300186# Based on Qt which needs to be installed to compile it
Linus Torvalds1da177e2005-04-16 15:20:36 -0700187# gconf: Used for the gconfig target
Diego Viola39c3f1b2015-05-31 14:35:51 -0300188# Based on GTK+ which needs to be installed to compile it
Linus Torvalds1da177e2005-04-16 15:20:36 -0700189# object files used by all kconfig flavours
190
Sam Ravnborg2982de62006-07-27 22:10:27 +0200191lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
192lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
193
Linus Torvalds1da177e2005-04-16 15:20:36 -0700194conf-objs := conf.o zconf.tab.o
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200195mconf-objs := mconf.o zconf.tab.o $(lxdialog)
196nconf-objs := nconf.o zconf.tab.o nconf.gui.o
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -0700197kxgettext-objs := kxgettext.o zconf.tab.o
Peter Foleyf1943042011-04-26 18:00:05 -0400198qconf-cxxobjs := qconf.o
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400199qconf-objs := zconf.tab.o
200gconf-objs := gconf.o zconf.tab.o
Linus Torvalds1da177e2005-04-16 15:20:36 -0700201
Masahiro Yamada022af622014-08-19 16:34:22 +0900202hostprogs-y := conf nconf mconf kxgettext qconf gconf
Linus Torvalds1da177e2005-04-16 15:20:36 -0700203
Masahiro Yamada29c83302017-12-10 01:02:30 +0900204targets += zconf.tab.c zconf.lex.c
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400205clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
Linus Torvaldsbb3290d2017-08-19 10:17:02 -0700206clean-files += zconf.tab.c zconf.lex.c gconf.glade.h
EGRY Gabor10200262008-01-11 23:40:00 +0100207clean-files += config.pot linux.pot
Linus Torvalds1da177e2005-04-16 15:20:36 -0700208
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100209# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
210PHONY += $(obj)/dochecklxdialog
Borislav Petkovff85a1a2017-05-21 11:44:47 +0200211$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100212$(obj)/dochecklxdialog:
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400213 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100214
215always := dochecklxdialog
216
Sam Ravnborgaa1e5ef2007-08-12 23:15:44 +0200217# Add environment specific flags
218HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
Yaakov Selkowitzd0fd0422018-01-16 14:44:45 -0600219HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
Yuri Vasilevski70a6a0c2005-10-30 15:03:20 -0800220
Linus Torvalds1da177e2005-04-16 15:20:36 -0700221# generated files seem to need this to find local include files
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400222HOSTCFLAGS_zconf.lex.o := -I$(src)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700223HOSTCFLAGS_zconf.tab.o := -I$(src)
224
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400225HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
226HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700227
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400228HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
Adrian Bunk37193142006-01-02 11:25:30 +0100229HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
Arnaud Lacombe1ea3ad42011-06-05 23:36:05 -0400230 -Wno-missing-prototypes
Linus Torvalds1da177e2005-04-16 15:20:36 -0700231
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400232HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
233
Justin Lecher544e7e52013-03-06 14:02:02 +0100234HOSTLOADLIBES_nconf = $(shell \
Brian Norris72859962014-06-04 00:52:31 -0700235 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
236 || pkg-config --libs menu panel ncurses 2>/dev/null \
Justin Lecher544e7e52013-03-06 14:02:02 +0100237 || echo "-lmenu -lpanel -lncurses" )
Linus Torvalds1da177e2005-04-16 15:20:36 -0700238$(obj)/qconf.o: $(obj)/.tmp_qtcheck
239
Masahiro Yamada022af622014-08-19 16:34:22 +0900240ifeq ($(MAKECMDGOALS),xconfig)
Roman Zippelb3a52252005-11-21 21:32:38 -0800241$(obj)/.tmp_qtcheck: $(src)/Makefile
Linus Torvalds1da177e2005-04-16 15:20:36 -0700242-include $(obj)/.tmp_qtcheck
243
Diego Viola092373c2015-04-06 06:27:45 -0300244# Qt needs some extra effort...
Linus Torvalds1da177e2005-04-16 15:20:36 -0700245$(obj)/.tmp_qtcheck:
Thiago Macieirad1b0dc92015-09-22 11:36:39 -0700246 @set -e; $(kecho) " CHECK qt"; \
Thiago Macieira588446a2015-11-01 21:12:53 -0600247 if pkg-config --exists Qt5Core; then \
248 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
249 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
250 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
251 elif pkg-config --exists QtCore; then \
252 cflags=`pkg-config --cflags QtCore QtGui`; \
253 libs=`pkg-config --libs QtCore QtGui`; \
254 moc=`pkg-config --variable=moc_location QtCore`; \
Sam Ravnborgab919c02005-11-06 11:05:21 +0100255 else \
Thiago Macieirad1b0dc92015-09-22 11:36:39 -0700256 echo >&2 "*"; \
Thiago Macieira588446a2015-11-01 21:12:53 -0600257 echo >&2 "* Could not find Qt via pkg-config."; \
258 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
Thiago Macieirad1b0dc92015-09-22 11:36:39 -0700259 echo >&2 "*"; \
260 exit 1; \
Roman Zippelb3a52252005-11-21 21:32:38 -0800261 fi; \
262 echo "KC_QT_CFLAGS=$$cflags" > $@; \
263 echo "KC_QT_LIBS=$$libs" >> $@; \
264 echo "KC_QT_MOC=$$moc" >> $@
Linus Torvalds1da177e2005-04-16 15:20:36 -0700265endif
266
267$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
268
Masahiro Yamada022af622014-08-19 16:34:22 +0900269ifeq ($(MAKECMDGOALS),gconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700270-include $(obj)/.tmp_gtkcheck
271
Diego Viola39c3f1b2015-05-31 14:35:51 -0300272# GTK+ needs some extra effort, too...
Linus Torvalds1da177e2005-04-16 15:20:36 -0700273$(obj)/.tmp_gtkcheck:
Adrian Bunk37193142006-01-02 11:25:30 +0100274 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
275 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700276 touch $@; \
277 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200278 echo >&2 "*"; \
279 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
280 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700281 false; \
282 fi \
283 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200284 echo >&2 "*"; \
285 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
286 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
287 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
288 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700289 false; \
290 fi
291endif
292
Linus Torvaldsbb3290d2017-08-19 10:17:02 -0700293$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
Linus Torvalds1da177e2005-04-16 15:20:36 -0700294
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400295$(obj)/qconf.o: $(obj)/qconf.moc
Linus Torvalds1da177e2005-04-16 15:20:36 -0700296
Yaakov Selkowitzebca0262012-07-04 18:31:11 -0500297quiet_cmd_moc = MOC $@
298 cmd_moc = $(KC_QT_MOC) -i $< -o $@
299
300$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
301 $(call cmd,moc)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700302
Diego Viola39c3f1b2015-05-31 14:35:51 -0300303# Extract gconf menu items for i18n support
EGRY Gabor46d26312008-01-11 23:46:11 +0100304$(obj)/gconf.glade.h: $(obj)/gconf.glade
Peter Foley2d80eb02011-04-26 18:16:53 -0400305 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
Peter Foleya24a1b82011-04-26 18:13:05 -0400306 $(obj)/gconf.glade